--- gimpfu.py	Thu Apr 10 21:30:53 2003
+++ gimpfu.py	Thu Apr 10 22:47:59 2003
@@ -151,6 +151,8 @@
 		plugin_type = PLUGIN
 	elif menupath[:10] == '<Toolbox>/':
 		plugin_type = EXTENSION
+	elif menupath[:7] in ("<Load>/", "<Save>/"):
+		plugin_type = PLUGIN
 	else:
 		raise error, "menu path must start with <Image> or <Toolbox>"
 
@@ -172,10 +174,15 @@
 
 		fn = lambda x: (_type_mapping[x[0]], x[1], x[2])
 		params = map(fn, params)
+
+		# test for load and save plug-ins
+		load_plugin = menupath[:7] == "<Load>/"
+		save_plugin = menupath[:7] == "<Save>/"
+
 		# add the run mode argument ...
 		params.insert(0, (PDB_INT32, "run_mode",
 				  "Interactive, Non-Interactive"))
-		if plugin_type == PLUGIN:
+		if plugin_type == PLUGIN and not load_plugin:
 			params.insert(1, (PDB_IMAGE, "image",
 					  "The image to work on"))
 			params.insert(2, (PDB_DRAWABLE, "drawable",
@@ -185,6 +192,11 @@
 				       date, menupath, imagetypes, plugin_type,
 				       params, results)
 
+		if load_plugin:
+			gimp.register_load_handler(plugin, "", "")
+		elif save_plugin:
+			gimp.register_save_handler(plugin, "", "")
+
 def _get_defaults(func_name):
 	import gimpshelf
 	(blurb, help, author, copyright, date,
@@ -391,6 +403,11 @@
 	run_mode = params[0]
 	plugin_type = _registered_plugins_[func_name][7]
 	func = _registered_plugins_[func_name][10]
+	menupath = _registered_plugins_[func_name][5]
+
+	# test for load and save plug-ins
+	load_plugin = menupath[:7] == "<Load>/"
+	save_plugin = menupath[:7] == "<Save>/"
 
 	if plugin_type == PLUGIN:
 		start_params = params[1:3]
@@ -399,7 +416,7 @@
 		start_params = ()
 		extra_params = params[1:]
 	
-	if run_mode == RUN_INTERACTIVE:
+	if run_mode == RUN_INTERACTIVE and not (load_plugin and len(extra_params) == 0):
 		extra_params = _interact(func_name)
 		if extra_params == None:
 			return
